set nocount on
go

use InMemoryOLTP2016
go

declare
	@PaymentDate datetime2(0) 
	,@CustomerId int
	,@Amount money 
	,@Status tinyint 
	,@PaymentId uniqueidentifier
	,@I int = 1

while 1 = 1
begin
	select @PaymentDate = dateadd(month,1,getUTCDate()), @CustomerId = @I % 16384 + 1;
	exec dbo.InsertPayments2016_06 	@PaymentDate, @CustomerId, 1000, 1, @PaymentId output;
	waitfor delay '0:00:00.050';

	;with CTE(PaymentDate, PaymentId, RowNum)
	as
	(
		select PaymentDate, PaymentId, ROW_NUMBER() over (order by PaymentDate)
		from dbo.Payments
		where PaymentDate >= '2016-06-01'
	)
	select @PaymentDate = PaymentDate, @PaymentId = PaymentId
	from CTE
	where RowNum = @I;
	exec dbo.UpdatePayments2016_06 @PaymentDate, @PaymentId, 20000, 2;
	waitfor delay '0:00:00.050';

	select top 1 @PaymentDate = PaymentDate, @PaymentId = PaymentId
	from dbo.Payments2016_06;
	exec dbo.DeletePayments2016_06 @PaymentDate, @PaymentId;
	waitfor delay '0:00:00.050';

	select @I = case when @I > 16384 then 1 else @I + 1 end;
	if @I % 10 = 0
		select @I as [@I];
end
go 